//Compare the properties of TFs at different types of locations
//(enhancers, TFs, etc) between conditions.

//IMPORTANT! This class is OBSOLETE and should not be used any more

//java -Xmx512m CompareTFsCondition -e Enhancers/enhancers_null_KCl.txt -n PeakFiles/compare_conditions_names.txt

//use compare_tfs_conditions.m to post-process the data.

import java.util.*;
import java.util.regex.*;
import java.text.DecimalFormat;
import jargs.gnu.CmdLineParser;
import java.io.*;

public class CompareTFsCondition {

    public static final String TF_ENHANCER_RATIOS_NAME = "_tfs_enhancer_ratios";
    public static final String TF_ENHANCER_VALUES_NAMES = "_tfs_enhancer_values";
    public static final String TF_ENHANCER_DIFFS_NAME = "_tfs_enhancer_diffs";
    public static final String NEARBY_TF_ENHANCER_RATIOS_NAME = "_nearby_tfs_enhancer_ratios";

    public static DecimalFormat format = new DecimalFormat("###.####");
    public static Random random = new Random();

    public static void main(String[] args) {
	try {
	    //Handle the flags
	    //Flags used at the moment: 
	    CmdLineParser argParser = new CmdLineParser();
	    CmdLineParser.Option chromosomeFlag = argParser.addIntegerOption('c', "chromosome");	    
	    CmdLineParser.Option orchestraFlag = argParser.addBooleanOption('o', "orchestra");
	    CmdLineParser.Option fileNameFlag = argParser.addStringOption('n', "fileName");
	    CmdLineParser.Option inputFileNameFlag = argParser.addStringOption('i', "inputFileName");
	    CmdLineParser.Option saveFileNameFlag = argParser.addStringOption('s', "saveFileName");
	    CmdLineParser.Option pValueFlag = argParser.addDoubleOption('P', "pValue");
	    CmdLineParser.Option nonGenicFlag = argParser.addBooleanOption("nonGenic");
	    //Location of the enhancer list
	    CmdLineParser.Option enhancerFileNameFlag = argParser.addStringOption('e', "enhancerFileName");
	    //Consider the density at TSSs as well
	    CmdLineParser.Option tssFlag = argParser.addBooleanOption("TSS");
	    CmdLineParser.Option windowSizeFlag = argParser.addIntegerOption('w', "windowSize");
	    CmdLineParser.Option maxEnhancer2TSSDistanceFlag = argParser.addIntegerOption('d', "maxEnhancer2TSSDistance");
	    CmdLineParser.Option nMCFlag = argParser.addIntegerOption('N', "nMC");
	    CmdLineParser.Option conservationFlag = argParser.addBooleanOption('C', "conservation");
	    //////////////////////////////////////////////////////////////////
	    //Parse the flags
	    argParser.parse(args);
	    //The latest version of CmdLineParser seems to remove the
	    //value foreach flag when you've looked at it once. Thus
	    //we adjust our code to work with the new version.
	    Object tmp;
	    tmp = argParser.getOptionValue(chromosomeFlag);
	    int chr = tmp!=null ? ((Integer)tmp).intValue() : -1;
	    boolean orchestra = argParser.getOptionValue(orchestraFlag)!=null;
	    boolean tss = argParser.getOptionValue(tssFlag)!=null;
	    boolean nonGenic = argParser.getOptionValue(nonGenicFlag)!=null;
	    String tssSaveFileName = tss ? (orchestra ? "/groups/neuroduo/martin/ChIP-Seq/TKData/" : "") + "Enhancers/tss_tf_ratios" : null;
	    tmp = argParser.getOptionValue(fileNameFlag);
	    String fileName = tmp!=null ? (String)tmp : null;
	    tmp = argParser.getOptionValue(inputFileNameFlag);
	    String inputFileName = tmp!=null ? (String)tmp : null;
	    tmp = argParser.getOptionValue(windowSizeFlag);
	    int windowSize = tmp!=null ? ((Integer)tmp).intValue() : 2000;
	    tmp = argParser.getOptionValue(pValueFlag);
	    double pValue = tmp!=null ? ((Double)tmp).doubleValue() : .005;
	    tmp = argParser.getOptionValue(enhancerFileNameFlag);
	    String enhancerFileName = tmp!=null ? (String)tmp : (orchestra ? "/groups/neuroduo/martin/ChIP-Seq/TKData/" : "") + "Enhancers/enhancers_null_KCl.txt";
	    tmp = argParser.getOptionValue(saveFileNameFlag);
	    String saveFileName = tmp!=null ? (String)tmp : enhancerFileName.substring(0, enhancerFileName.lastIndexOf(".")) + "_" + (fileName.contains(".") ? fileName.substring(fileName.lastIndexOf("/") + 1, fileName.lastIndexOf(".")) : fileName.substring(fileName.lastIndexOf("/") + 1)) + (inputFileName!=null ? "_input" : "");
	    String saveFileNameEnhancersNearTSS = tss ? saveFileName + "_near_tss" : null;
	    tmp = argParser.getOptionValue(maxEnhancer2TSSDistanceFlag);
	    int maxEnhancer2TSSDistance = tmp!=null ? ((Integer)tmp).intValue() : 100000;
	    tmp = argParser.getOptionValue(nMCFlag);
	    int nMC = tmp!=null ? ((Integer)tmp).intValue() : 1000;
	    boolean conservation = argParser.getOptionValue(conservationFlag)!=null;
	    //////////////////////////////////////////////////////////////////
	    int nChr = 21, nTSSs = 0, fragmentLength = 120;
	    double qualityScore = 10;
	    //Load the enhancer sites
	    Vector<Enhancer> enhancers = FindReadsAcrossFeature.parseEnhancerFile(enhancerFileName);
	    //Load the annotation
	    RefSeqGenes geneInfo[] = new RefSeqGenes[nChr];
	    for (int i=1; i<=nChr; i++) {
		if (chr==-1 || i==chr)
		    geneInfo[i-1] = new RefSeqGenes(i, orchestra);
	    }
	    //Parse the file with factor names
	    TreeMap<String, String> tfPairs = new TreeMap<String, String>();
	    TreeMap<String, Integer> nTotalReads = new TreeMap<String, Integer>();
	    if (fileName.contains("names")) {
		Vector<String> fileNames = new Vector<String>(), shortNames = new Vector<String>();
		fileNames = FindOverlappingPeaks.getFileNames(fileName, shortNames);
		//Find the pairs
		for (String s : fileNames) {
		    if (s.contains("mRNA")) {
			if (s.contains("0"))
			    tfPairs.put(s, s.replace("0", "6"));
			else
			    tfPairs.put(s, s.replace("6", "0"));
		    }
		    else if (!s.contains("Input")) {
			if (s.contains("un"))
			    tfPairs.put(s, s.replace("un", "KCl"));
			else
			    tfPairs.put(s.replace("KCl", "un"), s);
		    }
		}
	    }
	    else {
		if (fileName.contains("mRNA")) {
		    if (fileName.contains("0"))
			tfPairs.put(fileName, fileName.replace("0", "6"));
		    else
			tfPairs.put(fileName, fileName.replace("6", "0"));
		}
		else if (fileName.contains("un")) 
		    tfPairs.put(fileName, fileName.replace("un", "KCl"));
		else
		    tfPairs.put(fileName.replace("KCl", "un"), fileName);
	    }
	    String inputFileNameUn = null, inputFileNameKCl = null;
	    if (inputFileName!=null) {
		if (inputFileName.contains("un")) {
		    inputFileNameUn = inputFileName;
		    inputFileNameKCl = inputFileName.replace("un", "KCl");
		}
		else if (inputFileName.contains("KCl")) {
		    inputFileNameKCl = inputFileName;
		    inputFileNameUn = inputFileName.replace("un", "KCl");
		}
		else if (inputFileName.contains("MNase")) {
		    inputFileNameUn = inputFileName;
		    inputFileNameKCl = inputFileName;
		}
	    }
	    if (inputFileNameKCl!=null && inputFileNameUn!=null)
		tfPairs.put(inputFileNameUn, inputFileNameKCl);
	    TreeMap<String, Vector<Double>> tfRatios = new TreeMap<String, Vector<Double>>(), tfRatiosTSS = new TreeMap<String, Vector<Double>>(), tfRatiosNearbyEnhancersTSS = new TreeMap<String, Vector<Double>>();
	    //Keep track of the locations of all the ratio
	    Vector<String> tfLocStr = new Vector<String>(), tssLocStr = new Vector<String>();
	    TreeMap<Enhancer, TreeMap<String, Integer>> unEnhancer2ReadsMap = new TreeMap<Enhancer, TreeMap<String, Integer>>(), kclEnhancer2ReadsMap = new TreeMap<Enhancer, TreeMap<String, Integer>>();
	    for (String unName : tfPairs.keySet()) {
		boolean rna = unName.contains("RNA");
		String kclName = tfPairs.get(unName);
		tfRatios.put(unName, new Vector<Double>());
		tfRatiosTSS.put(unName, new Vector<Double>());
		tfRatiosNearbyEnhancersTSS.put(unName, new Vector<Double>());
		//Total number of reads for normalization
		nTotalReads.put(unName.replace(".", "_S."), 0);
		nTotalReads.put(kclName.replace(".", "_S."), 0);
		nTotalReads.put(unName.replace(".", "_AS."), 0);
		nTotalReads.put(kclName.replace(".", "_AS."), 0);
		//Get all the reads
		for (int i=1; i<=nChr; i++) {
		    if (i==chr || chr==-1) {
			ABIRead[] unReads = null, unReadsForward = null, unReadsReverse = null, kclReads = null, kclReadsForward = null, kclReadsReverse = null;
			if (rna) {
			    unReadsForward = FindNongenicTranscripts.loadMRNAReadsChr(unName, true, i);
			    unReadsReverse = FindNongenicTranscripts.loadMRNAReadsChr(unName, false, i);
			    kclReadsForward = FindNongenicTranscripts.loadMRNAReadsChr(kclName, true, i);
			    kclReadsReverse = FindNongenicTranscripts.loadMRNAReadsChr(kclName, false, i);
			    nTotalReads.put(unName.replace(".", "_S."), nTotalReads.get(unName.replace(".", "_S.")) + unReadsForward.length + unReadsReverse.length);
			    nTotalReads.put(unName.replace(".", "_AS."), nTotalReads.get(unName.replace(".", "_AS.")) + unReadsForward.length + unReadsReverse.length);
			    nTotalReads.put(kclName.replace(".", "_S."), nTotalReads.get(kclName.replace(".", "_S.")) + kclReadsForward.length + kclReadsReverse.length);
			    nTotalReads.put(kclName.replace(".", "_AS."), nTotalReads.get(kclName.replace(".", "_AS.")) + kclReadsForward.length + kclReadsReverse.length);
			}
			else {
			    unReads = PeakFinder2.parseFiles(i, unName, fragmentLength, true, 0, qualityScore);
			    kclReads = PeakFinder2.parseFiles(i, kclName, fragmentLength, true, 0, qualityScore);
			    if (unReads!=null)
				nTotalReads.put(unName, nTotalReads.get(unName) + unReads.length);
			    if (kclReads!=null)
				nTotalReads.put(kclName, nTotalReads.get(kclName) + kclReads.length);
			}
			//double totReadRatio = (double)unReads.length/kclReads.length; 
			//Go through all the enhancers and investigate the ratio of reads
			for (Enhancer en : enhancers) {
			    int c = en.getChromosome();
			    if (c==i && (!nonGenic || (nonGenic && !geneInfo[i-1].overlapsGene(en.getCenter())))) {
				if (!unEnhancer2ReadsMap.containsKey(en)) 
				    unEnhancer2ReadsMap.put(en, new TreeMap<String, Integer>());
				if (!kclEnhancer2ReadsMap.containsKey(en))
				    kclEnhancer2ReadsMap.put(en, new TreeMap<String, Integer>());				
				if (rna) {
				    RefSeqGene g = geneInfo[c-1].getOverlappingGene(en.getCenter());
				    g = g==null ? geneInfo[c-1].getNearestTSSGene(en.getCenter(), false) : g;
				    boolean strand = g.getStrand();
				    int nUnS = FindReadsAcrossFeature.numberOfReads(c, en.getCenter() - windowSize, en.getCenter() + windowSize, (strand ? unReadsForward : unReadsReverse));
				    unEnhancer2ReadsMap.get(en).put(unName.replace(".", "_S."), nUnS);
				    int nUnAS = FindReadsAcrossFeature.numberOfReads(c, en.getCenter() - windowSize, en.getCenter() + windowSize, (strand ? unReadsReverse : unReadsForward));
				    unEnhancer2ReadsMap.get(en).put(unName.replace(".", "_AS."), nUnAS);
				    int nKClS = FindReadsAcrossFeature.numberOfReads(c, en.getCenter() - windowSize, en.getCenter() + windowSize, (strand ? kclReadsForward : kclReadsReverse));
				    kclEnhancer2ReadsMap.get(en).put(kclName.replace(".", "_S."), nKClS);
				    int nKClAS = FindReadsAcrossFeature.numberOfReads(c, en.getCenter() - windowSize, en.getCenter() + windowSize, (strand ? kclReadsReverse : kclReadsForward));
				    kclEnhancer2ReadsMap.get(en).put(kclName.replace(".", "_AS."), nKClAS);
				}
				else {
				    if (unReads!=null)
					unEnhancer2ReadsMap.get(en).put(unName, FindReadsAcrossFeature.numberOfReads(c, en.getCenter() - windowSize, en.getCenter() + windowSize, fragmentLength, unReads));
				    else
					unEnhancer2ReadsMap.get(en).put(unName, 0);
				    if (kclReads!=null)
					kclEnhancer2ReadsMap.get(en).put(kclName, FindReadsAcrossFeature.numberOfReads(c, en.getCenter() - windowSize, en.getCenter() + windowSize, fragmentLength, kclReads));
				    else
					kclEnhancer2ReadsMap.get(en).put(kclName, 0);
				}
				//tfRatios.get(unName).addElement(totReadRatio*(double)(1 + nKCl)/(1 + nUn));
			    }
			}
			if (tss) {
			    for (RefSeqGene g : geneInfo[i-1].getGenes()) {
				int nUn = FindReadsAcrossFeature.numberOfReads(i, g.getStart() - windowSize, g.getStart() + windowSize, fragmentLength, unReads);
				int nKCl = FindReadsAcrossFeature.numberOfReads(i, g.getStart() - windowSize, g.getStart() + windowSize, fragmentLength, kclReads);
				//tfRatiosTSS.get(unName).addElement(totReadRatio*(double)(1 + nKCl)/(1 + nUn));
				String cStr = g.getChromosome()==20 ? "chrX" : g.getChromosome()==21 ? "chrY" : "chr" + g.getChromosome();
				tssLocStr.addElement(cStr + ":" + (g.getStart() - windowSize) + "-" + (g.getStart() + windowSize));
				////////////////////////////////////////////
				//Compare with the enhancers that are found within a given cut-off distance.
				Vector<Enhancer> nearbyEnhancers = new Vector<Enhancer>();
				double ratio = 0;
				for (Enhancer en : enhancers) {
				    if (en.getChromosome()==g.getChromosome() && Math.abs(g.getStart() - en.getCenter())<maxEnhancer2TSSDistance) {
					nearbyEnhancers.addElement(en);
					//ratio += ((double)(1 + kclEnhancer2ReadsMap.get(en)))/(1 + unEnhancer2ReadsMap.get(en));
				    }
				}
				//Calculate the average induction levels across these enhancers
				ratio = nearbyEnhancers.size()>0 ? ratio/nearbyEnhancers.size() : 1;
				//if (nearbyEnhancers.size()>0)
				//  System.out.println("Found " + nearbyEnhancers.size() + " enhancers near " + g.toString());
				tfRatiosNearbyEnhancersTSS.get(unName).addElement(ratio);
			    }
			}
		    }
		}
		System.out.println("Loaded reads for " + unName);
	    }
	    ///////////////////////////////////////////////////////
	    //Save the distributions of TFs near enhancers and TSSs
	    saveValues(unEnhancer2ReadsMap, kclEnhancer2ReadsMap, nTotalReads, saveFileName + TF_ENHANCER_VALUES_NAMES + (nonGenic ? "_intergenic" : "") + "_w_" + windowSize + (chr==-1 ? "" : "_" + chr ) + ".txt");
	    //saveRatios(tfRatios, tfLocStr, saveFileName + TF_ENHANCER_RATIOS_NAME + "_w_" + windowSize + (chr==-1 ? "" : "_" + chr ) + ".txt");
	    //saveDiffs(unEnhancer2ReadsMap, kclEnhancer2ReadsMap, nTotalReads, windowSize, saveFileName + TF_ENHANCER_DIFFS_NAME + "_w_" + windowSize + (chr==-1 ? "" : "_" + chr ) + ".txt");
	    if (tss) {
		saveRatios(tfRatiosTSS, tssLocStr, tssSaveFileName + "_w_" + windowSize + (chr==-1 ? "" : "_" + chr ) + ".txt");
		saveRatios(tfRatiosNearbyEnhancersTSS, tssLocStr, saveFileName + NEARBY_TF_ENHANCER_RATIOS_NAME + "_w_" + windowSize + (chr==-1 ? "" : "_" + chr ) + ".txt");
	    }
	} catch (Exception e) {
	    System.err.println("Caught exception " + e.toString());
	    StackTraceElement s[] = e.getStackTrace();
	    for(int i=0; i<s.length; i++)
		System.err.println(s[i].toString());
	} // end of try-catch
    } // end of main()

    //////////////////////////////////////////////////////////////////

    public static void saveRatios(TreeMap<String, Vector<Double>> tfRatios, Vector<String> tfLocStr, String saveName) throws IOException {
	System.out.println("Saving to " + saveName);
	BufferedWriter bw = new BufferedWriter(new FileWriter(saveName));
	bw.write("#Pos\t");
	for (String k : tfRatios.keySet()) {
	    Pattern tfPattern = Pattern.compile("/(\\w+)[_|\\.]\\w+$");
	    Matcher m = tfPattern.matcher(k);
	    if (m.find())
		bw.write(m.group(1) + "\t");
	}
	bw.write("\n");
	for (int i=0; i<tfRatios.get(tfRatios.firstKey()).size(); i++) {
	    bw.write(tfLocStr.elementAt(i) + "\t");
	    for (String k : tfRatios.keySet()) 
		bw.write(format.format(tfRatios.get(k).elementAt(i)) + "\t");
	    bw.write("\n");
	}
	bw.close();
    }

    public static void saveValues(TreeMap<Enhancer, TreeMap<String, Integer>> unEnhancer2ReadsMap, TreeMap<Enhancer, TreeMap<String, Integer>> kclEnhancer2ReadsMap, TreeMap<String, Integer> nTotalReads, String saveName) throws IOException {
	System.out.println("Saving to " + saveName);
	String inputUnName = null, inputKClName = null;
	BufferedWriter bw = new BufferedWriter(new FileWriter(saveName));
	TreeMap<String, Double> unNormFactor = new TreeMap<String, Double>(), kclNormFactor = new TreeMap<String, Double>();
	Vector<String> unNames = new Vector<String>(unEnhancer2ReadsMap.get(unEnhancer2ReadsMap.firstKey()).keySet());
	for (String k : unNames) {
	    System.out.println(k + " has " + nTotalReads.get(k) + " reads and norm factor " + format.format((double)CreateBedFiles.READS_NORMALIZATION_FACTOR/nTotalReads.get(k)));
	    unNormFactor.put(k, (double)CreateBedFiles.READS_NORMALIZATION_FACTOR/nTotalReads.get(k));
	    if (k.contains("Input")) { inputUnName = k; }
	}
	Vector<String> kclNames = new Vector<String>(kclEnhancer2ReadsMap.get(kclEnhancer2ReadsMap.firstKey()).keySet());
	for (String k : kclNames)  {
	    System.out.println(k + " has " + nTotalReads.get(k) + " reads and norm factor " + format.format((double)CreateBedFiles.READS_NORMALIZATION_FACTOR/nTotalReads.get(k)));
	    kclNormFactor.put(k, (double)CreateBedFiles.READS_NORMALIZATION_FACTOR/nTotalReads.get(k));
	    if (k.contains("Input")) { inputKClName = k; }
	}
	bw.write("#chr\tpos\t");
	for (String k : unNames) {
	    Pattern tfPattern = Pattern.compile("/([\\w|_]+)[\\.\\w]*$");
	    Matcher m = tfPattern.matcher(k);
	    if (m.find() && !k.contains("Input")) {
		if (m.group().contains("un") )
		    bw.write(m.group(1) + "\t" + m.group(1).replace("un", "KCl") + "\t");
		else if (m.group().contains("0") )
		    bw.write(m.group(1) + "\t" + m.group(1).replace("0", "6") + "\t");
	    }
	}
	bw.write("\n");
	for (Enhancer en : unEnhancer2ReadsMap.keySet()) {
	    bw.write(en.getChromosome() + "\t" + en.getCenter() + "\t");
	    for (int i=0; i<unNames.size(); i++) {
		if (!unNames.elementAt(i).contains("Input")) {
		    String kclName = kclNames.elementAt(i);
		    String unName = unNames.elementAt(i);
		    bw.write(format.format(unNormFactor.get(unName)*(double)unEnhancer2ReadsMap.get(en).get(unName) -  (inputUnName!=null ? unNormFactor.get(inputUnName)*(double)unEnhancer2ReadsMap.get(en).get(inputUnName) : 0)) + "\t" + format.format(kclNormFactor.get(kclName)*(double)kclEnhancer2ReadsMap.get(en).get(kclName) -  (inputKClName!=null ? kclNormFactor.get(inputKClName)*(double)kclEnhancer2ReadsMap.get(en).get(inputKClName) : 0)) + "\t");
		    //System.out.println("For enhancer " + en.toString() + "\n" + unEnhancer2ReadsMap.get(en).get(unName) + "\t" + unEnhancer2ReadsMap.get(en).get(inputUnName) + "\t" + kclEnhancer2ReadsMap.get(en).get(kclName) + "\t" + kclEnhancer2ReadsMap.get(en).get(inputKClName));
		}
	    }
	    bw.write("\n");
	}
	bw.close();
    }

    public static void saveDiffs(TreeMap<Enhancer, TreeMap<String, Integer>> unEnhancer2ReadsMap, TreeMap<Enhancer, TreeMap<String, Integer>> kclEnhancer2ReadsMap, TreeMap<String, Integer> nTotalReads, int windowSize, String saveName) throws IOException {
	System.out.println("Saving to " + saveName);
	//calculate the normalization coefficients
	TreeMap<String, Double> unNormFactor = new TreeMap<String, Double>(), kclNormFactor = new TreeMap<String, Double>();
	Vector<String> unNames = new Vector<String>(unEnhancer2ReadsMap.get(unEnhancer2ReadsMap.firstKey()).keySet());
	for (String k : unNames) {
	    System.out.println(k);
	    unNormFactor.put(k, (double)CreateBedFiles.READS_NORMALIZATION_FACTOR/nTotalReads.get(k));
	}
	Vector<String> kclNames = new Vector<String>(kclEnhancer2ReadsMap.get(kclEnhancer2ReadsMap.firstKey()).keySet());
	for (String k : kclNames)  {
	    System.out.println(k);
	    kclNormFactor.put(k, (double)CreateBedFiles.READS_NORMALIZATION_FACTOR/nTotalReads.get(k));
	}
	BufferedWriter bw = new BufferedWriter(new FileWriter(saveName));
	bw.write("#Pos\t");
	for (String k : unNames) {
	    Pattern tfPattern = Pattern.compile("/(\\w+)[_|\\.]\\w+$");
	    Matcher m = tfPattern.matcher(k);
	    if (m.find())
		bw.write(m.group(1) + "\t");
	}
	bw.write("\n");
	for (Enhancer en : unEnhancer2ReadsMap.keySet()) {
	    int c = en.getChromosome();
	    String cStr = c==20 ? "chrX" : c==21 ? "chrY" : "chr" + c;
	    bw.write(cStr + ":" + (en.getCenter() - windowSize) + "-" + (en.getCenter() + windowSize) + "\t");
	    for (int i=0; i<unNames.size(); i++) {
		String kclName = kclNames.elementAt(i);
		String unName = unNames.elementAt(i);
		bw.write(format.format(kclNormFactor.get(kclName)*(double)kclEnhancer2ReadsMap.get(en).get(kclName) - unNormFactor.get(unName)*(double)unEnhancer2ReadsMap.get(en).get(unName)) + "\t");
	    }
	    bw.write("\n");
	}
	bw.close();
    }

}

