public class ConservationIsland implements Comparable {

    protected int start, end, chr, type = -1;
    protected double regulatoryScore;

    public ConservationIsland(int c, int s, int e) {
	chr = c;
	start = s;
	end = e;
    }

    public ConservationIsland(int c, int s, int e, int t) {
	chr = c;
	start = s;
	end = e;
	type = t;
    }

    public int getStart() { return start; }

    public int getEnd() { return end; }

    public int getCenter() { return (start + end)/2; }

    public int getLength() { return end - start; }

    public void setRegulatoryScore(double s) { regulatoryScore = s; }

    public double getRegulatoryScore() { return regulatoryScore; }
    
    public int getChromosome() { return chr; }

    public int getType() { return type; }

    public void setType(int t) { type = t; }

    public boolean overlaps(int s, int e) {
	return (start<=s && end>=s) || (start<=e && end>=e) || (start>s && end<e);
    }

    public boolean overlaps(int p) {
	return (start<=p && end>=p);
    }

    public boolean equals(Object o) {
	if (!(o instanceof ConservationIsland))
	    return false;
	ConservationIsland e = (ConservationIsland)o;
	return e.chr==chr && e.start==start && e.end==end;
    }

    public int compareTo(Object o) {
	if (!(o instanceof ConservationIsland))
	    return 0;
	ConservationIsland e = (ConservationIsland)o;
	if (chr<e.chr)
	    return -1;
	else if (chr>e.chr)
	    return 1;
	else {
	    if (start<e.start)
		return -1;
	    else if (start>e.start)
		return 1;
	    else {
		if (end<e.end)
		    return -1;
		else if (end>e.end)
		    return 1;
		else
		    return 0;
	    }
	}
    }

    public int hashCode() {
	return start*23 + end*41 + chr*89;
    }

    public String toString() {
	return "chr" + chr + ":" + start + "-" + end + (type!=-1 ? "\t" + type : "");
    }

}