//Use this class to represent the mRNA seq data for an annotated gene
	
import java.text.DecimalFormat;

public class RNASeqGene implements Comparable {

    public static DecimalFormat format = new DecimalFormat("###.####");

    //The annotation data
    protected RefSeqGene annotation;
    
    protected double exonDensity, transcriptDensity;

    public RNASeqGene(RefSeqGene g) {
	annotation = g;
    }

    public void setExonDensity(double d) { exonDensity = d; }

    public double getExonDensity() { return exonDensity; }

    public void setTranscriptDensity(double d) { transcriptDensity = d; }

    public double getTranscriptDensity() { return transcriptDensity; }

    public RefSeqGene getAnnotationInfo() { return annotation; }

    //////////////////////////////////////////////////////////////////

    public int compareTo(Object o) {
	if (!(o instanceof RNASeqGene))
	    System.err.println("ERROR comparing RNA-Seq data!");
	RNASeqGene r = (RNASeqGene)o;
	return annotation.compareTo(r.annotation);
    }

    public boolean equals(Object o) {
	if (!(o instanceof RNASeqGene))
	    return false;
	RNASeqGene r = (RNASeqGene)o;
	return r.annotation.equals(annotation);
    }

    public String toString() {
	return annotation.toString() + "\t" + format.format(exonDensity);
    }

    public int hashCode() { return annotation.hashCode(); }

}
